<?php

class ConfigController extends ivController
{
	/**
	 * Pre-dispatching
	 *
	 */
	function _preDispatch()
	{
		if (!ivAcl::isAdmin()) {
			$this->_forward('login', 'cred');
			if (ivAuth::getCurrentUserLogin()) {
				ivMessenger::add('error', "You don't have access to this page");
			}
			return;
		}
	}
	
	/**
	 * Default action (edit main config)
	 *
	 */
	function indexAction()
	{
		$crumbs = &ivPool::get('breadCrumbs');
		$crumbs->push('config', 'index.php?c=config');
		$configFile = CONFIG_FILE;
		if (isset($_POST['save']) && isset($_POST['config'])) {
			$xml = ivXml::readFromFile($configFile, DEFAULT_CONFIG_FILE);
			foreach ($_POST['config'] as $path => $value) {
				$node = &$xml->findByXPath($path);
				if ($node) {
					if (get_magic_quotes_gpc()) {
						$node->setValue(stripslashes(is_array($value) ? implode(',', $value): (string) $value));
					} else {
						$node->setValue(is_array($value) ? implode(',', $value): (string) $value);
					}
				}
			}
			$result = $xml->writeToFile();
			if ($result) {
				ivMessenger::add('notice', 'Configuration successfully saved');
			} else {
				ivMessenger::add('error', "Can't save configuration file " . substr(CONFIG_FILE, strlen(BASE_DIR)));
			}
		}

		$xml = ivXml::readFromFile($configFile, DEFAULT_CONFIG_FILE);
		
		$this->view->assign('flatConfig', $xml->toFlatTree());
		$this->view->assign('langs', $this->_getLangs());
	}
	
	/**
	 * Return list of langs file
	 *
	 * @return array
	 * @todo Kill this function
	 */
	function _getLangs()
	{
		$content = getContent(LANGS_DIR);
		$list = array();
		foreach ($content as $item) {
			if (ivFilepath::matchSuffix($item, array('xml'))) {
				$list[] = $item;
			}
		}
		sort($list);
		return $list;
	}
	
	/**
	 * Edit language
	 *
	 */
	function langAction()
	{
		$crumbs = &ivPool::get('breadCrumbs');
		$crumbs->push('config', 'index.php?c=config');
		$lang = $this->_getParam('name', 'english');
		if (!ctype_alnum($lang)) {
			ivMessenger::add('error', 'Use only alphanumeric symbols in language name');
			$this->_redirect('index.php?c=config');
		}
		$this->view->assign('lang', $lang);
		$crumbs->push($lang, 'index.php?c=config&amp;a=lang&amp;name=' . $lang);
		$configFile = LANGS_DIR . $lang . '.xml';
		if (isset($_POST['save']) && isset($_POST['lang'])) {
			$xml = ivXml::readFromFile($configFile, DEFAULT_LANG_FILE);
			foreach ($_POST['lang'] as $path => $value) {
				$node = &$xml->findByXPath($path);
				if ($node) {
					if (get_magic_quotes_gpc()) {
						$node->setValue(stripslashes($value));
					} else {
						$node->setValue((string) $value);
					}
				}
			}
			$result = $xml->writeToFile();
			if ($result) {
				ivMessenger::add('notice', "Language file $lang.xml succesfully saved");
			} else {
				ivMessenger::add('error', "Can't save language file $lang.xml");
			}
		}

		$xml = ivXml::readFromFile($configFile, DEFAULT_LANG_FILE);

		$this->view->assign('flatConfig', $xml->toFlatTree());
		$this->view->assign('langs', $this->_getLangs());
	}

}
?>