<?php

class ConfigController extends ivController
{
	/**
	 * Default action (edit main config)
	 *
	 */
	function indexAction()
	{
		$crumbs = &ivPool::get('breadCrumbs');
		$crumbs->push('config', 'index.php?c=config');

		$xml = ivXml::readFromFile(CONFIG_FILE, DEFAULT_CONFIG_FILE);
		
		$this->view->assign('flatConfig', $xml->toFlatTree());
		$this->view->assign('langs', $this->_getLangs());
	}
	
	/**
	 * Return list of langs file
	 *
	 * @return array
	 * @todo Kill this function
	 */
	function _getLangs()
	{
		$content = getContent(LANGS_DIR);
		$list = array();
		foreach ($content as $item) {
			if (ivFilepath::matchSuffix($item, array('xml'))) {
				$list[] = $item;
			}
		}
		sort($list);
		return $list;
	}
	
	/**
	 * Edit language
	 *
	 */
	function langAction()
	{
		$crumbs = &ivPool::get('breadCrumbs');
		$crumbs->push('config', 'index.php?c=config');
		$lang = $this->_getParam('name', 'english');
		if (!ctype_alnum($lang)) {
			ivMessenger::add('error', 'Use only alphanumeric symbols in language name');
			$this->_redirect('index.php?c=config');
		}
		$this->view->assign('lang', $lang);
		$crumbs->push($lang, 'index.php?c=config&amp;a=lang&amp;name=' . $lang);
		$configFile = LANGS_DIR . $lang . '.xml';

		$xml = ivXml::readFromFile($configFile, DEFAULT_LANG_FILE);
		
		$this->view->assign('flatConfig', $xml->toFlatTree());
		$this->view->assign('langs', $this->_getLangs());
	}

}
?>